package fr.mael.jiwigo.ui.mainframe;

import java.awt.FlowLayout;

import javax.swing.JOptionPane;
import javax.swing.JPanel;

import fr.mael.jiwigo.om.Category;
import fr.mael.jiwigo.om.Image;
import fr.mael.jiwigo.service.ImageService;
import fr.mael.jiwigo.transverse.util.Messages;
import fr.mael.jiwigo.transverse.util.Outil;
import fr.mael.jiwigo.ui.ImagesManagement;
import fr.mael.jiwigo.ui.layout.VerticalLayout;

/**
   Copyright (c) 2010, Mael
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of jiwigo nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   DISCLAIMED. IN NO EVENT SHALL Mael BE LIABLE FOR ANY
   DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   
 * @author mael
 * Classe qui affiche toutes les miniatures d'une catégorie
 */
public class ThumbnailSearchPanel extends JPanel implements IThumbnailPanel {
    /**
     * Logger
     */
    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
	    .getLog(ThumbnailSearchPanel.class);

    /**
     * fake category id = -1
     */
    private Integer categoryId;

    /**
     * fake category
     */
    private Category category;

    /**
     * query made by user
     */
    private String queryString;

    /**
     * Constructeur
     * @param categoryId l'id de la catégorie
     */
    public ThumbnailSearchPanel(String queryString) {
	this.categoryId = -1;
	category = new Category();
	category.setIdentifiant(-1);
	category.setNom(Messages.getMessage("mainFrame_recherche"));
	this.queryString = queryString;
	this.setLayout(new VerticalLayout());
	rechercher();
    }

    /**
     *refreshes
     * @param categoryId the id of the category
     */
    public void rechercher() {
	this.removeAll();
	int nb = 1;
	JPanel panelh = new JPanel(new FlowLayout());
	try {
	    MainFrame.getInstance().setMessage(Messages.getMessage("thumbviewer_loading"));
	    ImagesManagement.LIST_IMAGE = ImageService.getInstance().search(queryString);
	    for (Image image : ImagesManagement.LIST_IMAGE) {
		try {

		    if (nb == 7) {
			this.add(panelh);
			panelh = new JPanel(new FlowLayout());
			nb = 0;
		    } else {
			ThumbnailPanel panel = new ThumbnailPanel(image);
			panelh.add(panel);
		    }
		    nb++;

		} catch (Exception e) {

		}
	    }
	    if (nb != 8) {
		this.add(panelh);
	    }
	    this.repaint();
	    this.revalidate();
	    MainFrame.getInstance().setMessage(Messages.getMessage("loadingOk"));
	} catch (Exception e) {
	    LOG.error(Outil.getStackTrace(e));
	    JOptionPane.showMessageDialog(null, Messages.getMessage("imagesListingError"),
		    Messages.getMessage("error"), JOptionPane.ERROR_MESSAGE);
	    MainFrame.getInstance().setMessage(Messages.getMessage("imagesListingError"));
	}
    }

    /**
     * @return the categoryId
     */
    public Integer getCategoryId() {
	return categoryId;
    }

    /**
     * @param categoryId the categoryId to set
     */
    public void setCategoryId(Integer categoryId) {
	this.categoryId = categoryId;
    }

    /**
     * @return the category
     */
    public Category getCategory() {
	return category;
    }

    /**
     * @param category the category to set
     */
    public void setCategory(Category category) {
	this.category = category;
    }

    /**
     * @return the queryString
     */
    public String getQueryString() {
	return queryString;
    }

}
